2006-10-16  Koji Arai  <arai@users.sourceforge.jp>

	* released.

2006-10-11  Koji Arai  <arai@users.sourceforge.jp>

	* configure.ac: updated version and my mail address.

2006-10-09  Koji Arai  <arai@users.sourceforge.jp>

	* src/lha_macro.h (MIN): newly added a macro for below.

	* maketbl.c (make_table): applied the security patch for the
	CVE-2006-4335 and CVE-2006-4337.

	* huf.c (read_pt_len, read_c_len, decode_c_st1, decode_p_st1):
	applied the security patch for the CVE-2006-4338.

2005-09-24  Koji Arai  <jca02266@nifty.com>

	* released.

	* configure.ac: updated version and my mail address.

	* Hacking_of_LHa: updated. (2003-02-23 edition)

	* 00readme.autoconf: updated.

2005-06-08  Koji Arai  <jca02266@nifty.ne.jp>

	* configure.ac: updated version.

	* src/lharc.c (parse_suboption): fixed a bug, when the
	--system-kanji-code option specified, the --archive-kanji-code
	option was infected.

2005-05-08  Koji Arai  <jca02266@nifty.ne.jp>

	* configure.ac: updated version.

	* src/lharc.c (print_usage): updated.

	* src/lhadd.c, src/header.c (remove_leading_dots): move to
	header.c for readlink().

	* src/lhadd.c (add_one): symbolic link indication was contrary.
	( not "realname -> linkname" but "linkname -> realname" )
	(delete): ditto.

	* src/lhext.c (extract_one): ditto.

	* src/lhlist.c (list_one): ditto.

	* tests/lha-test14: ditto.

	* src/lhadd.c (remove_leading_dots): newly added.

	* src/lhadd.c (append_it): remove leading relative path from
	archive.

	* src/lhext.c (is_directory_traversal): should return true when
	just ".." was found.

2004-10-02  Koji Arai  <jca02266@nifty.ne.jp>

	* src/lharc.c (print_tiny_usage): added long option helps.

	* src/prototypes.h: updated.

	* src/lharc.c: should accept a single option --help and --version.

2004-09-29  Koji Arai  <jca02266@nifty.ne.jp>

	* src/lharc.c (parse_option, parse_suboption): use getopt_long().

	* src/Makefile.am: added getopt_long.c and getopt_long.h.

	* src/getopt_long.c, src/getopt_long.h: newly added.

2004-09-29  Koji Arai  <jca02266@nifty.ne.jp>

	* released.

	* 00readme.autoconf: note for builds on MS-Windows.

	* configure.ac: updated version.

	* Makefile.am: added Hacking_of_LHa in EXTRA_DIST.

	* Hacking_of_LHa: renamed (typo).

2004-09-27  Koji Arai  <jca02266@nifty.ne.jp>

	* configure.ac: updated version.

	* src/prototypes.h (str_safe_copy): newly added.
	(build_standard_archive_name, build_backup_file):
	added argument the size for build_standard_archive_name() and
	build_backup_file().

	* src/header.c (init_header): use str_safe_copy() instead of strcpy().

	* src/lhadd.c (build_backup_file, cmd_add, cmd_delete):
	added argument the size for build_standard_archive_name() and
	build_backup_file().

	* src/lhext.c (make_parent_path): use str_safe_copy() instead of strcpy().
	(extract_one): ditto.

	* src/lharc.c (find_files): use str_safe_copy() instead of strcpy().
	(build_temporary_name): ditto.
	(modify_filename_extention): ditto.
	(build_backup_name): ditto.
	(build_standard_archive_name): ditto.

	* src/util.c (str_safe_copy): newly added.

2004-09-26  Koji Arai  <jca02266@nifty.ne.jp>

	* src/header.c: fixed typo.

2004-09-18  Koji Arai  <jca02266@nifty.ne.jp>

	* configure.ac: updated version.

	* 00readme.autoconf: added a description about
	`--extract-broken-archive' option.

	* src/lharc.c (init_variable, parse_option): added an option
	`--extract-broken-archive' to extract broken archive.

	* src/lha.h (extract_broken_archive): ditto.

	* src/slide.c (encode, decode): fixed a *FATAL* bug which make a
	broken archive.

2004-05-08  Koji Arai  <jca02266@nifty.ne.jp>

	* configure.ac: updated version.

	* src/prototypes.h: updated.

	* src/lhext.c (extract_one, is_directory_traversal): applied a
	security patch (CAN-2004-0235: directory traversal problems)

	* src/lharc.c (print_usage): updated.

2003-12-18  Koji Arai  <jca02266@nifty.ne.jp>

	* src/header.c (wintime_to_unix_stamp): no use 64bit constant to
	avoid the warning `integer constant is too large for "long" type'
	on GCC. however, for portability, no use the unsigned long long
	suffix "ULL".

2003-12-13  Koji Arai  <jca02266@nifty.ne.jp>

	* configure.ac: updated version.

	* src/lhext.c (extract_one, cmd_extract): preserve directory
	timestamp. Thanks Akihiro Iriyama.

	* src/lhext.c (add_dirinfo, adjust_dirinfo): newly added.

2003-09-28  Koji Arai  <jca02266@nifty.ne.jp>

	* Makefile.am (SUBDIRS): reordered to avoid useless re-compilation.

2003-09-21  Koji Arai  <jca02266@nifty.ne.jp>

	* released.

	* configure.ac: updated version.

2003-08-18  Koji Arai  <jca02266@nifty.ne.jp>

	* 00readme.autoconf: fixed.

	* configure.ac: use AC_SYS_LARGEFILE for largefile support.

	* config.h.in: ditto.

	* src/prototypes.h: updated.

2003-07-29  Koji Arai  <jca02266@nifty.ne.jp>

	* tests/Makefile.am (EXTRA_DIST): lha-test1 was missed.

	* tests/lha-test13: should set LANG=C for `tr'.

2003-07-28  Koji Arai  <jca02266@nifty.ne.jp>

	* tests/lha-test.in: filename should be contained in last error
	information.

2003-07-27  Koji Arai  <jca02266@nifty.ne.jp>

	* tests/lha-test2: no need to set $FILENAME.
	* tests/lha-test3: ditto.
	* tests/lha-test4: ditto.
	* tests/lha-test5: ditto.
	* tests/lha-test6: ditto.
	* tests/lha-test7: ditto.
	* tests/lha-test8: ditto.
	* tests/lha-test9: ditto.
	* tests/lha-test10: ditto.
	* tests/lha-test11: ditto.
	* tests/lha-test12: ditto.
	* tests/lha-test13: ditto.
	* tests/lha-test14: ditto.
	* tests/lha-test15: ditto.

	* tests/lha-test1: newly added.

	* tests/lha-test.in: improved.

	* src/prototypes.h: updated.

	* src/lha.h (exit): defined as lha_exit().

	* src/lharc.c (init_variable): discard a variable
	`remove_temporary_at_error'.
	(fatal_error): ditto.
	(cleanup): newly added.
	(interrupt): call cleanup().
	(lha_exit): newly added; cleanup temporary files always.

	* src/lhadd.c (add_one): discard a variable
	`remove_temporary_at_error'.

	* src/indicator.c (start_indicator): refined.

	* src/lharc.c (parse_option): fixed typo.

	* src/indicator.c (carriage_return): newly added; print CR on tty only.
	(start_indicator): call above.
	(finish_indicator): ditto.
	(finish_indicator2): ditto.

	* src/lharc.c (print_usage): newly added.
	(parse_option): strictly checking command line arguments.
	(main): ditto.

2003-07-26  Koji Arai  <jca02266@nifty.ne.jp>

	* tests/lha-test13: use `tr' instead of `printf` for printing 8 bit
	characters.

2003-07-25  Koji Arai  <jca02266@nifty.ne.jp>

	* tests/lha-test14: `test -e' is unavailable on some systems.

2003-07-22  Koji Arai  <jca02266@nifty.ne.jp>

	* tests/lha-test.in: should exit with status in trap.

	* src/shuf.c (decode_start_st0): wrong value was assigned.

	* src/lha.h: discard `prof' variable.

	* src/lharc.c (init_variable): discard `prof' variable.
	(parse_option): discard undocumented `p' option.
	(main): ditto.

	* src/append.c (encode_lzhuf): hate global variable.

	* src/extract.c (decode_lzhuf): ditto.

	* src/lha.h: ditto.

2003-07-21  Koji Arai  <jca02266@nifty.ne.jp>

	* configure.ac: updated version.

	* 00readme.autoconf: described largefiles.

	* src/header.c (get_header): avoid valgrind warning, `Source and
	destination overlap in strncpy()'.

	* src/lharc.c (find_files): refined.

	* tests/lha-test.in: should exit in trap.

	* src/lharc.c (find_files): uninitialized variable was caught by
	Valgrind.

	* src/prototypes.h: updated.

	* src/append.c (encode_lzhuf): set actual copied size.

	* src/util.c (encode_stored_crc): use size_t instead of long.

	* src/lhadd.c (temporary_to_new_archive_file): ditto.
	(cmd_add): ditto.
	(cmd_delete): ditto.

	* src/lhadd.c (add_one): fixed a comment.

	* src/indicator.c (MAX_INDICATOR_COUNT): changed to fit for the 80
	column screen.

	* src/extract.c (decode_lzhuf): refined.

	* src/prototypes.h: updated.

	* src/cproto.sh: added `indicator.c'.

	* src/Makefile.am: ditto.

	* src/indicator.c: separated from append.c.

	* src/append.c: ditto.

	* src/lha.h: ditto.

	* src/lha_macro.h: ditto.

2003-07-20  Koji Arai  <jca02266@nifty.ne.jp>

	* configure.ac: updated version.

	* src/Makefile.am (EXTRA_DIST): fnmatch.h was missed.

	* src/lha.h (fseeko, ftello): these macros had no effect.

2003-07-19  Koji Arai  <jca02266@nifty.ne.jp>

	* src/maketree.c (make_len): discard debug print.

	* configure.ac: updated version.

	* src/prototypes.h: updated.

	* config.h.in: updated.

	* configure.ac: check declaration of `basename'.

	* src/cproto.sh: ditto.

	* src/util.c (encode_stored_crc): use size_t.

	* src/lha.h (struct LzHeader): use size_t for the members
	`packed_size' and `original_size'.

2003-07-13  Koji Arai  <jca02266@nifty.ne.jp>

	* configure.ac: updated version.

	* src/prototypes.h: updated.

	* src/append.c (encode_lzhuf): use size_t and off_t instead of long.
	(start_indicator): ditto.

	* src/extract.c (decode_lzhuf): ditto.

	* src/lha.h (struct interfacing): ditto.

	* src/lhadd.c (add_one): ditto.
	(find_update_files): ditto.
	(delete): ditto.

	* src/lhext.c (cmd_extract): ditto.

	* src/util.c (copyfile): ditto.

	* src/lhlist.c (print_size): use "%7lu" format string instead of
	"%7ld" for large files.

	* src/slide.c: refined.

2003-07-11  Koji Arai  <jca02266@nifty.ne.jp>

	* src/lharc.c (cleaning_files): should print errno.

2003-05-23  Koji Arai  <jca02266@nifty.ne.jp>

	* configure.ac: use fseeko(), ftello() instead of fseek(), ftell().

	* config.h.in: ditto.

	* src/lha.h, src/lhlist.c, src/lhext.c, src/lharc.c: ditto.

	* src/lhadd.c, src/header.c: ditto.

2003-05-10  Koji Arai  <jca02266@nifty.ne.jp>

	* configure.ac: updated version.

	* src/lhext.c (inquire_extract): warning if stdin is not tty,
	because you cannot reply from stdin.
	(extract_one): return actual read size from archive.
	(cmd_extract): fix a bug: skip correct size when error occurred.

	* tests/lha-test5: added tests for above.

	* src/lha.h (struct interfacing): added a member `read_size'.

	* src/extract.c (decode_lzhuf): added an argument `pointer of
	read_size'.

	* src/prototypes.h: ditto.

	* src/slide.c (decode): set actual read size to interface->read_size.

2003-04-14  Koji Arai  <jca02266@nifty.ne.jp>

	* src/cproto.sh: The cproto 4.7a supports some gcc-specific keywords.

2003-03-24  Koji Arai  <jca02266@nifty.ne.jp>

	* configure.ac: updated version.

	* src/prototypes.h: updated.

2003-03-23  Koji Arai  <jca02266@nifty.ne.jp>

	* src/header.c (convert_filename): support Samba CAP code (experimental).
	(hex2int, int2hex, cap_to_sjis, sjis_to_cap): added for above.

	* src/lha_macro.h (CODE_CAP): ditto.

	* src/lharc.c (parse_option): added new command line options,
	--system-kanji-code=xxx and --archive-kanji-code=xxx (experimental).

	* 00readme.autoconf: described above features.

2003-03-22  Koji Arai  <jca02266@nifty.ne.jp>

	* src/lharc.c (init_variable): do not use HEADER_LEVELx macros.
	(parse_option): ditto.

	* src/header.c (write_header): ditto.

	* src/lha_macro.h (HEADER_LEVEL0, HEADER_LEVEL1, HEADER_LEVEL2, MATCHBIT): ditto.

	* src/huf.c (encode_start_st1): do not use assert().
	(decode_start_st1): ditto.

2003-03-12  Koji Arai  <jca02266@nifty.ne.jp>

	* src/header.c (wintime_to_unix_stamp): should cast to unsigned type.

2003-03-03  Koji Arai  <jca02266@nifty.ne.jp>

	* src/prototypes.h: updated.

	* src/cproto.sh: improved.

2003-02-24  Koji Arai  <jca02266@nifty.ne.jp>

	* src/prototypes.h: updated.

	* src/maketree.c: hate global variables.

	* src/lha_macro.h: refined.

	* src/huf.c: refined.

	* src/util.c (strdup): defined more properly.
	(memset): ditto.

	* prototypes.h: ditto.

	* cproto.sh: ditto.

2003-02-23  Koji Arai  <jca02266@nifty.ne.jp>

	* src/cproto.sh: improved.

	* src/prototypes.h: updated.

	* src/util.c: `strucmp()' was replaced by `strcasecmp()'.

	* src/util.c (archive_is_msdos_sfx1): ditto.

	* src/lharc.c (open_old_archive): ditto.

	* src/lha.h: ditto.

	* src/util.c: discard `rename()', `mkdir()' and `rmdir()'.

	* configure.ac: ditto.

	* config.h.in: ditto.

	* src/header.c: added credit.
	no longer use `ftime()', `tzset()', `localtime()' and `gettimeofday()'.

2003-02-17  Koji Arai  <jca02266@nifty.ne.jp>

	* configure.ac: updated version.

	* src/fnmatch.h: no need to include <sys/cdefs.h>. it does not
	exist on MinGW.

2003-02-14  Koji Arai  <jca02266@nifty.ne.jp>

	* src/lharc.c (find_files): `goto' requires expression after label.

	* src/lhadd.c (cmd_add): ditto.

2003-02-05  Koji Arai  <jca02266@nifty.ne.jp>

	* tests/lha-test7: sleep 1 to make sure for updating tests.

	* src/fnmatch.c, src/fnmatch.h: added fnmatch.c derived from the
	OpenBSD.

2003-02-04  Koji Arai  <jca02266@nifty.ne.jp>

	* configure.ac: need to call `AC_CANONICAL_HOST' for automake
	1.6.x (for installing the config.guess and config.sub).

2003-02-02  Koji Arai  <jca02266@nifty.ne.jp>

	* src/header.c, src/lharc.c: fix credit.

2003-01-20  Koji Arai  <jca02266@nifty.ne.jp>

	* src/lha.h (prev_char): discard unused variable `prev_char'.

	* src/crcio.c (fwrite_txt): ditto.

	* src/slide.c (decode): ditto.

	* src/slide.c: refined a little.

2003-01-19  Koji Arai  <jca02266@nifty.ne.jp>

	* src/slide.c: took off the debug flag.

	* src/slide.c (search_dict): split into 2 parts.

	* src/slide.c: refined: use the structure `matchdata'.

2003-01-18  Koji Arai  <jca02266@nifty.ne.jp>

	* src/lha.h (decode_count): rename a global variable `count' to
	`decode_count'.

	* src/dhuf.c (decode_p_dyn): ditto.

	* src/slide.c (decode): ditto and refined.

2003-01-17  Koji Arai  <jca02266@nifty.ne.jp>

	* src/slide.c: refined ?

	* src/slide.c (INIT_HASH, NEXT_HASH): newly defined to refine.

2003-01-13  Koji Arai  <jca02266@nifty.ne.jp>

	* src/prototypes.h: updated.

	* src/slide.c: refined.

2002-12-31  Koji Arai  <jca02266@nifty.ne.jp>

	* src/lhext.c (adjust_info): On Cygwin, execute permission should
	be set for .exe or .dll.

2002-12-28  Koji Arai  <jca02266@nifty.ne.jp>

	* src/lha_macro.h (peekbits): newly added.

	* src/huf.c (read_pt_len): use peekbits().
	(read_c_len): ditto.
	(decode_c_st1): ditto.
	(decode_p_st1): ditto.

	* src/shuf.c (decode_c_st0): ditto.
	(decode_p_st0): ditto.

2002-12-23  Koji Arai  <jca02266@nifty.ne.jp>

	* configure.ac: added a configure option: --enable-ignore-dot-files.

	* config.h.in: ditto.

	* src/lharc.c (parse_option): added `-X' option to ignore dot files.

2002-12-17  Koji Arai  <jca02266@nifty.ne.jp>

	* configure.ac: should check whether system has `ssize_t'.

	* config.h.in: ditto.

	* lha.h: ditto.

	* configure.ac: added checking functions `fnmatch' and `basename'.
	but not yet prepare the free fnmatch.c.

	* config.h.in: ditto.

	* src/util.c (basename): newly added.

	* src/lhadd.c (cmd_add): exclude files specified by -x option.

	* src/lharc.c (print_tiny_usage): refined.

2002-12-16  Koji Arai  <jca02266@nifty.ne.jp>

	* 00readme.autoconf: describe about new feature `-x'.

	* src/lha.h: include fnmatch.h.
	added a global variable `exclude_files'.

	* src/lharc.c (init_variable): initialize `exclude_files'.
	(print_tiny_usage): modify usage.
	(parse_option): newly added. should regard leading `-' argument as
	option (for new -x option).
	added `-x <pattern>' option (specify exclude files pattern).
	(find_files): files matched by pattern `exclude_files' exclude
	from target files.

2002-11-25  Koji Arai  <jca02266@nifty.ne.jp>

	* src/header.c: use size_t for header_size.
	(skip_msdos_sfx1_code): rename to `seek_lha_header()'.

	* src/lha.h: use size_t for header_size.

	* src/lhadd.c (cmd_add): rename `skip_msdos_sfx1_code()' to
	`seek_lha_header()'.
	(cmd_delete): ditto.

	* src/lhext.c (cmd_extract): ditto.

	* src/lhlist.c (cmd_list): ditto.

	* src/prototypes.h: updated.

	* tests/lha-test15: added tests to search any level headers.

2002-11-17  Koji Arai  <jca02266@nifty.ne.jp>

	* untabify all sources.

	* src/huf.c (encode_start_st1): refined.
	(decode_start_st1): refined.

	* src/slide.c (encode_alloc): refined.
	(update): refined.

2002-11-15  Koji Arai  <jca02266@nifty.ne.jp>

	* 00readme.autoconf: updated.

	* src/prototypes.h: updated.

	* configure.ac, Makefile.am, olddoc/Makefile.am:
	  old documentations moved to olddoc directory.

	* CHANGES.euc, MACHINES2.euc, README.euc, change-114h.txt, change-114e.txt, change-114i.txt, IFNAMES, Makefile.in, change-114f.txt, config.eng, MACHINES.euc, PROBLEMS.euc, change-114g.txt, config.jpn.euc: ditto.

	* Makefile.in.org, src/Makefile.in.org: removed.

	* configure.ac: updated version (source maintenance start on
	sourceforge.jp)

2002-11-11  Koji Arai  <jca02266@nifty.ne.jp>

	* src/lhext.c (make_parent_path): On Cygwin, when `foo.exe'
	exists, stat("foo", &buf) is successful and it is not a directory.

	* src/util.c (skip_msdos_sfx1_code): move to header.c

	* src/header.c (skip_msdos_sfx1_code): ditto.
	some macro moved from lha_macro.h.

	* src/lha_macro.h: ditto.

	* tests/lha-test15: newly added for testing self extracting archive.

	* tests/lha-test.in: ditto.

	* tests/Makefile.am: ditto.

	* configure.ac: refined messages.

2002-10-26  Koji Arai  <jca02266@nifty.ne.jp>

	* src/bitio.c (putbits): use the function putcode().

	* src/dhuf.c (decode_start_dyn): call init_code_cache().

	* src/huf.c (encode_start_st1): ditto.
	(decode_start_st1): ditto.

	* src/larc.c (decode_start_lzs): ditto.

	* src/shuf.c (decode_start_st0): ditto.
	(encode_start_fix): ditto.
	(decode_start_fix): ditto.

	* src/Makefile.am: added bitio.c

	* src/cproto.sh: added bitio.c

	* src/bitio.c: new file.

	* src/crcio.c: extracted bitio routines.

	* src/lha.h: ditto.

2002-10-16  Koji Arai  <jca02266@nifty.ne.jp>

	* 00readme.autoconf: modified.

2002-10-02  Koji Arai  <jca02266@nifty.ne.jp>

	* src/util.c (xstrchr): `strchr(s, 0)' should return the pointer
	of the '\0' terminator.

2002-09-14  Koji Arai  <jca02266@nifty.ne.jp>

	* src/lhadd.c (add_one): Use chsize() if system does not have
	ftruncate(2). (For MinGW)

	* configure.ac: ditto.

	* config.h.in: ditto.

2002-09-03  Koji Arai  <jca02266@nifty.ne.jp>

	* released.

	* 00readme.autoconf: modified for stable release.

	* configure.ac: updated version.

2002-09-01  Koji Arai  <jca02266@nifty.ne.jp>

	* tests/Makefile.am (EXTRA_DIST): lha-test12, lha-test13 and
	lha-test14 were missed.

2002-08-31  Koji Arai  <jca02266@nifty.ne.jp>

	* src/lhadd.c (append_it): refined.

	* src/lhadd.c (append_it): no terminate when file cannot be opened.

2002-08-29  Koji Arai  <jca02266@nifty.ne.jp>

	* tests/lha-test11: change the way of checking the `header size field'.

	* configure.ac: the `--enable-user-name-header' switch has been
	ineffective. corrected variable name.

2002-08-26  Koji Arai  <jca02266@nifty.ne.jp>

	* tests/lha-test14: on Cygwin, cannot use '|' as filesname.

	* tests/lha-test.in: on MinGW, skip lha-test14 test.

	* 00readme.autoconf: modified.

	* released.

	* configure.ac: updated version.

	* src/header.c: fixed a comment.

	* src/prototypes.h (strcmp_filename): removed.

	* src/header.c (dump_skip_bytes): note "ignored" if data is ignored.

	* src/header.c (wintime_to_unix_stamp): newly added for converting
	from `FILETIME' to `time_t'.
	(get_extended_header): use `wintime_to_unix_stamp()' to recognize
	the Windows time stamp header (0x41).

	* src/lha.h: define `uint64_t' unless system has it.

	* configure.ac: check existence of the type `uint64_t'.

	* config.h.in: ditto.

	* src/lharc.c (init_variable): set default header level to 2.

2002-08-24  Koji Arai  <jca02266@nifty.ne.jp>

	* tests/lha-test.in (lha-test14): added to test the symbolic link file.

	* tests/lha-test14: ditto.

	* src/lhlist.c (list_one): use LzHeader.realname.

	* src/lhext.c (extract_one): use LzHeader.realname.
	should call make_parent_path(symlink).

	* src/lhadd.c (add_one): use LzHeader.realname.
	(delete): ditto.
	(append_it): use strcmp() instead of strcmp_filename().
	(strcmp_filename): removed.

	* src/lha.h (struct LzHeader): added a member `realname' which is
	symbolic linked name.

	* src/header.c (get_header): split symbolic name in archive.
	(write_header): join symbolic link name and linked name to put it
	in archive.

	* src/lhext.c (extract_one): force extract when `f' option is
	specified. this is for OS-9 archives, [provisional].

	* src/header.c: fixed cpp expressions around time functions.

	* tests/lha-test8: test MS-DOS timestamp `ftime' structure.

	* tests/lha-test.in (change_timestamp): newly added.

2002-08-22  Koji Arai  <jca02266@nifty.ne.jp>

	* released.

	* src/prototypes.h: regenerated.

	* src/cproto.sh: refined.

	* configure.ac: updated version.

	* configure.ac: should use `exit' rather than `return' on
	AC_TRY_RUN().  see the Autoconf manual.

	* configure.ac: check whether the 2nd argument of gettimeofday()
	is effective.

	* src/header.c: ditto.

	* config.h.in (GETTIMEOFDAY_HAS_2ND_ARG): ditto.

	* tests/lha-test.in: `++' is invalid arithmetic operator on POSIX
	shell, Ksh and Bash version 2.03 or earlier.

	* tests/lha-test13: ditto.

2002-08-18  Koji Arai  <jca02266@nifty.ne.jp>

	* src/lharc.c (print_version): version string is made here.

	* src/lha_macro.h (LHA_VERSION): removed.

	* src/slide.c (encode_alloc): used newly named `dicbit' macro.

	* src/shuf.c (read_tree_p): ditto.
	(decode_start_fix): ditto.

	* src/lha_macro.h: `xxx_DICBIT' for each method was defined.

	* src/header.c: correct a comment `Generic stamp format'.
	(get_bytes): fixed for dumping header.

	* src/lha_macro.h, src/lha.h: `EXTERN' macro definition was moved
	to lha.h.

	* src/header.c (get_bytes): print hex codes for invisible chars.

	* src/lhlist.c: hate global variables.

	* src/prototypes.h (convdelim): removed.

	* src/lhlist.c (print_stamp): use ISO 8601 date format when `lha vv'.

2002-08-14  Koji Arai  <jca02266@nifty.ne.jp>

	* src/header.c: discarded warning message for the extended header,
	`Windows time stamp' ignored.

	* src/header.c: in spite of extended type value, read contents of
	any ext headers.

	* src/header.c: comment fixed.

2002-08-12  Koji Arai  <jca02266@nifty.ne.jp>

	* src/header.c (dump_skip_bytes): do nothing when length is 0.

2002-08-11  Koji Arai  <jca02266@nifty.ne.jp>

	* src/lha_macro.h (SJC_FIRST_P): rename to SJIS_FIRST_P.
	(SJC_SECOND_P): rename to SJIS_SECOND_P.

	* src/util.c (convdelim): removed.

	* src/header.c (convert_filename): when small letter is included
	in filename, do not convert case.

	* tests/lha-test.in, tests/lha-test2, tests/lha-test3, tests/lha-test4, tests/lha-test5, tests/lha-test6, tests/lha-test7, tests/lha-test8, tests/lha-test9, tests/lha-test10, tests/lha-test11, tests/lha-test12, tests/lha-test13:
	print filename when test failed.

	* tests/lha-test.in, tests/lha-test12, tests/lha-test13:
	added tests for converting text files.

	* src/header.c (get_extended_header): recognize the Windows time
	stamp header (0x41), but ignored.

	* src/header.c (write_unix_info): added.

2002-08-11  Koji Arai  <jca02266@nifty.ne.jp>

	* released.

	* configure.ac: updated version.

	* 00readme.autoconf: modified.

	* src/header.c: DUMP_HEADER is always true.
	dump header when running `lha vvv foo.lzh'.
	(get_header): added new extend type JAVA.

	* src/lha_macro.h (EXTEND_JAVA): added new extend type JAVA.

	* src/lhlist.c (list_one): ditto.

	* src/lharc.c (init_variable): `verbose' is changed to successive.
	(main): ditto.

2002-08-10  Koji Arai  <jca02266@nifty.ne.jp>

	* src/lhlist.c (list_one): fixed mode checks.

	* src/prototypes.h: updated.

	* src/header.c (get_header_level2): check CRC value for reading
	level 2 and 3 header.
	(get_header_level3): ditto.
	(get_extended_header): ditto.
	(get_header_level0): set total header size to
	`LzHeader.header_size' even if level 0 or 1 header is read.
	(get_header_level1): ditto.

	* src/append.c (encode_lzhuf): encode(), decode() and copyfile()
	were changed.
	(put_indicator): moved from crcio.c.

	* src/crcio.c (put_indicator): moved to append.c.
	(calccrc): generalized.
	(fread_crc): changed interface.
	(fwrite_crc): changed interface.
	(calc_header_crc): removed. use calccrc() instead.

	* src/extract.c (decode_lzhuf): copyfile() and decode() were changed.

	* src/lha.h: hate global variable. `crc' is removed.
	`reading_size' moved to append.c.

	* src/lha_macro.h (INITIALIZE_CRC): newly added.
	(UPDATE_CRC): no update in macro code.

	* src/lhadd.c (temporary_to_new_archive_file): copyfile() was changed.

	* src/lharc.c (copy_old_one): header size adjusting is done by
	the get_header().

	* src/slide.c (update): changed interface.
	(get_next): ditto.
	(encode): ditto.
	(decode): ditto.

	* src/util.c (copyfile): changed interface.

2002-08-10  Koji Arai  <jca02266@nifty.ne.jp>

	* tests/lha-test5: added tests using pipe.

	* src/lhadd.c (cmd_add): applied reverse patch.  intermediate file
	is the necessary when created archive put in pipe.

	* src/header.c (skip_bytes): newly added.
	(dump_get_byte): newly added for dumping the data for debugging.
	(dump_skip_bytes): ditto.
	(get_word): ditto.
	(get_longword): ditto.
	(get_bytes): ditto.
	(get_extended_header): modified for reading the level 3 header.
	(get_header_level3): newly added.

	* src/lha.h (struct LzHeader): for level 3 header, added a new
	member `size_field_length' and changed type of the `header_size'
	from int to long.

	* src/header.c (init_header): the `hdr->method' should be
	initialized to the "-lh0-" for empty files.

	* tests/lha-test2: ditto.

	* src/lhadd.c (add_one): should print indicator for empty files.

2002-08-09  Koji Arai  <jca02266@nifty.ne.jp>

	* tests/lha-test.in: adapt to ksh (and posix shell).

2002-08-05  Koji Arai  <jca02266@nifty.ne.jp>

	* 00readme.autoconf: refined.

	* config.h.in (BACKUP_OLD_ARCHIVE): added.

	* configure.ac: added a command line switch `--enable-backup-archive'.

	* src/lhadd.c (cmd_add): if `backup_old_archive' is true, no
	backup archive.
	(cmd_delete): ditto.

	* src/lharc.c (init_variable): initialize `backup_old_archive'.

	* src/lha.h (backup_old_archive): added for nobackup.

2002-08-02  Koji Arai  <jca02266@nifty.ne.jp>

	* src/lha_macro.h, src/lha.h, src/header.c, src/lhadd.c: Fixed
	misspelling, not `STRAGE' but `STORAGE'.

2002-07-29  Koji Arai  <jca02266@nifty.ne.jp>

	* re-released.

	* src/header.c: should use error() instead of fatal_error().
	(get_header): fixed wrong end mark checking.

	* src/prototypes.h: updated.

	* released.

	* configure.ac: updated version.

	* 00readme.autoconf: described about header.c bug on original lha.

2002-07-28  Koji Arai  <jca02266@nifty.ne.jp>

	* tests/Makefile.am: added lha-test11.

	* src/crcio.c (fread_txt): responded to (gcc -Wall) compiler warnings.

	* src/header.c (generic_to_unix_stamp): ditto.

	* src/lha_macro.h: ditto.

	* src/lhadd.c (delete): ditto.

	* src/lharc.c (open_old_archive): ditto.

	* src/lhlist.c (list_one): ditto.

	* src/prototypes.h: updated.

	* tests/lha-test.in: added lha-test11.

	* tests/lha-test8: added tests for level 0 and 2 header.

	* tests/lha-test10: added tests for generic header.

	* tests/lha-test11: testing for long filename. moved from lha-test10.

2002-07-26  Koji Arai  <jca02266@nifty.ne.jp>

	* src/header.c (write_header): rewritten.

2002-07-25  Koji Arai  <jca02266@nifty.ne.jp>

	* tests/lha-test4: stderr should be redirected.

	* src/lharc.c (main): exit with status 1 (meaning failure) when the
	function error() was called.
	(error): ditto.

	* src/lha.h (LzHeader.last_modified_stamp;): no longer used it.

	* src/header.c (get_header): rewritten.

2002-07-21  Koji Arai  <jca02266@nifty.ne.jp>

	* tests/lha-test10: change grep pattern so that pattern matches
	a carriage return at the end of line for MinGW.

	* src/lha.h: define `struct utimbuf' when utime.h is not given
	such as MinGW. (Microsoft Visual Studio 6.0 has sys/utime.h).

	* src/lhext.c (make_parent_path): missing braces.

	* tests/lha-test.in (check): print script line number when test failed.

	* tests/lha-test2, tests/lha-test3, tests/lha-test4, tests/lha-test5, tests/lha-test6, tests/lha-test7, tests/lha-test8, tests/lha-test9, tests/lha-test10: ditto.

	* tests/lha-test10: on Cygwin/MinGW, could not make 255 bytes
	filename. (the system limit of filename length contains the length
	of current directory.)

	* tests/lha-test10: should use /bin/ls instead of ls, since
	/usr/ucb/ls puts size on 4th field (on Solaris).

2002-07-18  Koji Arai  <jca02266@nifty.ne.jp>

	* released.

	* configure.ac: updated version.

	* src/lhext.c (adjust_info): should use `struct utimbuf' for
	`utime(2)' rather than `time_t' array.

	* src/header.c (write_header): [BUG]: should not write zero at the
	first byte on level 2 header. should adjust header size.

	* tests/lha-test10: added tests for level 2 header.

	* src/lha_macro.h, src/header.c (setup_get): moved to header.c.
	(get_byte): ditto.
	(put_ptr): ditto.
	(setup_put): ditto.
	(put_byte): ditto.
	(get_bytes): newly added.
	(put_bytes): newly added.

2002-07-17  Koji Arai  <jca02266@nifty.ne.jp>

	* src/header.c (get_header): [BUG]: Could not read level 2 header
	when the header size is grater than 256.
	(convert_filename): Should use the `FILENAME_LENGTH' macro rather
	than 256.
	(write_header): [BUG]: Suppress to overflow the header size when
	long filename is written in level 0 or 1 header. On level 1
	header, always use the extended filename header instead of the
	base header.

	* src/lha.h (LzHeader): the type of `header_size' was changed
	from `unsigned char' to `int', for the level 2 header archive.

	* src/lhext.c (extract_one): should use the `FILENAME_LENGTH'
	macro rather than 256 (provisionally fixed).

	* tests/lha-test.in: notify failed test number.

	* tests/lha-test10: added tests for long pathname.

2002-07-14  Koji Arai  <jca02266@nifty.ne.jp>

	* re-released.

	* src/header.c (get_header): archive path separator should be
	converted always.

	* released.

	* configure.ac: updated version.

	* src/header.c (write_header): if user/group name is not set,
	extended header (0x52 and 0x53) should not be made.

	* tests/lha-test10: added testing to handle deep directory.

	* src/header.c (write_header): fixed typo, not strchr() but
	strrchr().

	* src/prototypes.h: regenerated.

	* src/header.c (convert_filename): prefer to use the
	`FILENAME_LENGTH' macro rather than 256.

	* src/cproto.sh: fixed typo.

2002-07-11  Koji Arai  <jca02266@nifty.ne.jp>

	* tests/Makefile.am (EXTRA_DIST): lha-test9 and lha-test10 were missed.

	* src/lharc.c (print_tiny_usage): no exit here.

	* src/header.c (ConvertEncodingByIconv): newly added.
	Thanks to Hiroto Sakai.

	* configure.ac, config.h.in: Checking to have iconv() for utf-8
	conversion.

	* configure.ac: Checking whether strrchr() is 8 bit clean or not.
	On Mac OS X, strchr() can handle 8 bit characters, but strrchr()
	cannot.
	Should use '\377' rather than '\xff' for de-ANSI compiler.

2002-07-10  Koji Arai  <jca02266@nifty.ne.jp>

	* released.

	* configure.ac: updated version.

	* src/header.c: change hex codes '\xff' to octal codes '\377'.

	* tests/lha-test.in: Skip the lha-test9. (this test is imcomplete
	for now)

	* tests/lha-test10: Should extract directory even if the archive
	header was level 0.

	* src/header.c (get_header): Should convert kanji code and path
	separator for the level 0 header entry.
	Should convert `\' to `/' for level 0 header (do always to make sure,
	SO CANNOT CONTAIN THE `\' IN FILENAME).
	(init_header): [BUG]: Should not convert path separator here (Should do
	in write_header()).
	(write_header): [BUG]: should set pathname (contains directory part) to
	the LzHeader.name field on level 0 header archive even if the
	archive methods is -lhd-.

2002-07-09  Koji Arai  <jca02266@nifty.ne.jp>

	* src/lha.h, src/header.c: the CoreFoundation header inclusion
	moved to header.c.

	* src/lha.h, src/lharc.c, IFNAMES: macro NODIRECTORY was removed.

	* src/lha.h, src/lhadd.c, src/lharc.c, src/lhext.c: fixed
	misspelling, not `writting' but `writing'.

2002-07-07  Koji Arai  <jca02266@nifty.ne.jp>

	* src/lha.h, src/lha_macro.h: refined.

	* src/lhadd.c (append_it): macro STRING_COMPARE() was discarded.

	* src/lha_macro.h: ditto.

	* IFNAMES: NOVOID was removed.

	* src/lharc.c (main): terminate with exit status 2 when specified
	command line switche is wrong,

	* configure.ac, config.h.in: added checking utime.h existent.

	* src/crcio.c (putc_euc): void returned.

	* src/header.c, src/lha.h, src/lha_macro.h, src/lhadd.c: refined.

	* src/lharc.c, src/prototypes.h, src/slide.c: refined.

	* configure.ac: should specify the 4th argument to AC_TRY_RUN()
	for cross compiling.

	* configure.ac: fix a test expression.

	* src/cproto.sh: added for maintainer.

	* src/lha.h: support de-ANSI variable arguments.

	* src/lharc.c: ditto.

	* src/util.c: ditto.

	* src/Makefile.am (lha_SOURCES): added prototypes.h.

	* src/lha.h: function prototypes moved to prototypes.h.

	* src/prototypes.h: generated by the cproto command.

	* configure.ac: On Mac OS X, in spite of using the CoreFoundation
	for utf-8 conversion, I have missed specifying the `-framework
	CoreFoundation' in LDFLAGS.

	* src/Makefile.am (EXTRA_DIST): no need to specify `lhdir.c'.

2002-07-06  Koji Arai  <jca02266@nifty.ne.jp>

	* released.

	* configure.ac: updated version.

	* tests/lha-test10: added testing the header level 0, 1 and 2.

	* tests/lha-test.in: ditto.

	* src/lharc.c: `#include <stdarg.h>' moved to lha.h.

	* src/lha.h: ditto.

	* src/util.c: ditto.

	* configure.ac: AC_REPLACE_FUNCS(vsnprintf).

	* config.h.in: ditto.

	* src/lha.h: ditto.

	* src/vsnprintf.c: derived snprintf() which has the BSD licence.

	* configure.ac: fix typo.

	* configure.ac: checking whether strchr() is 8 bit clean or not.

	* config.h.in: ditto.

	* src/util.c: give functions strchr(), strrchr(), memchr() and
	memrchr() which handle 8 bit characters correctly.

	* src/header.c: use above if needed.

	* src/lha_macro.h: deprecate the macro name `DELIM2' which is path
	separattor for the filename in lha header.
	use LHA_PATHSEP instead.

	* src/util.c (convdelim): ditto.

	* src/header.c (convert_filename): ditto.
	(write_header): ditto.

	* src/header.c (convert_filename): fixed bug on utf8 conversion,
	provisionally.

2002-06-30  Koji Arai  <jca02266@nifty.ne.jp>

	* configure.ac: fixed typo.

	* src/header.c (sjis_to_utf8): fixed typo.
	(utf8_to_sjis): fixed typo.

	* src/lhadd.c (cmd_add): Missed to adjust the index when specified
	adding file is same as the generating archive file.

2002-06-29  Koji Arai  <jca02266@nifty.ne.jp>

	* src/header.c (convert_filename): rename a function
	`filename_conv()' to `convert_filename()'.
	(sjis_to_utf8_static): no use the static variable.
	(utf8_to_sjis_static): ditto.

	* src/lha.h: rename sjis_to_utf8_static() and utf8_to_sjis_static()
	into sjis_to_utf8() and utf8_to_sjis().

	* src/lha_macro.h: added a macro `CODE_UTF8'.

	* configure.ac: decide CODE_UTF8.
	updated version.

	* 00readme.autoconf: modified.

	* configure.ac: modified for Mac OS X.

	* src/header.c, lha.h, lha_macro.h, lharc.c: Merged a patch for
	the Mac OS X, convert utf-8 filename to shift_jis. This patch was
	contributed on LHa BBS. Thanks to Hiroto Sakai.

	* src/lhext.c: replaced bcmp() with memcmp().

	* src/lha_macro.h: ditto.

	* src/append.c: replace bcopy() with memcpy() or memmove().

	* src/lha_macro.h: ditto.

	* src/lhadd.c: ditto.

	* src/lharc.c: ditto.

	* src/header.c: ditto.
	replace bzero() with memset().

	* src/lhadd.c (cmd_add): exlclude the target archive. (reported on
	the LHa BBS [28])

	* src/slide.c (encode_alloc): Wrong value was assigned to the
	`dicbit', when SUPPORT_LH7 was not defined. (fixed by DANGAN,
	reported on the LHa BBS [38]).

	* src/lha_macro.h: ditto.

	* src/shuf.c (decode_c_st0): the method of -lh3- extraction was
	fixed by DANGAN (reported on the LHa BBS [35]).

	* src/lha_macro.h (LH3_DICBIT): ditto.

	* src/dhuf.c (encode_c_dyn): the method of -lh1- compression was
	refined by DANGAN (reported on the LHa BBS [30], [39], [62]).

2002-06-26  Koji Arai  <jca02266@nifty.ne.jp>

	* tests/lha-test4: Skip a test for the LHa for UNIX (original version).

	* tests/lha-test3: Rewrite tests for generic format archives.

	* tests/lha-test2: Added tests for -lh0- method.
	Moved from contents of lha-test3 (tests for print archive).

2002-06-23  Koji Arai  <jca02266@nifty.ne.jp>

	* tests/lha-test.in: On Cygwin/MinGW, cannot test lha-test9.

	* src/lhext.c: Fixed a misspelling. not `Symblic' but `Symbolic'.
	  reported on LHa BBS (see <http://www2m.biglobe.ne.jp/~dolphin/>).

	* src/lharc.c: ditto.

	* src/slide.c (interface;): Fixed wrong index.
	  reported on LHa BBS (see <http://www2m.biglobe.ne.jp/~dolphin/>).

	* 00readme.autoconf: refined.

	* tests/lha-test9: added tests for overriding files.

	* tests/lha-test.in: added test9.

	* src/lhext.c (cmd_extract): ftell(stdin) will return -1, so
	re-fixed provisionaly.

	* src/lhext.c (cmd_extract): When error occurred in extract_one(),
	should adjust point of file stream.

	* configure.ac: library checkings (for libmingwex) should be done
	before header checkings.

2002-06-22  Koji Arai  <jca02266@nifty.ne.jp>

	* released:

	* configure.ac: updated version.

	* src/lharc.c (init_variable): Removed useless assignments.

	* src/lharc.c (main): Behavior was changed. when `q' or `q2' option
	(not `q1') is specified, the `f' option is enabled implicitly.
	In original behavior, the option `q', `q0', `q1' and `q2' will
	enable `f' option implicitly (bug?).

	* src/lharc.c (main): [BUG]: When `q2' option is specified,
	level 2 header is generated.

2002-06-21  Koji Arai  <jca02266@nifty.ne.jp>

	* tests/Makefile.am: Use the `DISTCLEANFILES' variable instead of the `dist-hook' target.

	* tests/Makefile.am: Added `dist-hook' target for `make distcheck'.

	* tests/lha-test.in: All tests are splited into some files.

	* tests/Makefile.am: ditto.

	* tests/lha-test2: ditto.

	* tests/lha-test3: ditto.

	* tests/lha-test4: ditto.

	* tests/lha-test5: ditto.

	* tests/lha-test6: ditto.

	* tests/lha-test7: ditto.

	* tests/lha-test8: ditto.

2002-06-20  Koji Arai  <jca02266@nifty.ne.jp>

	* src/lhadd.c (cmd_add): No create an intermediate file when archive
	is written in stdout.

2002-06-19  Koji Arai  <jca02266@nifty.ne.jp>

	* 00readme.autoconf: Modified.

2002-06-18  Koji Arai  <jca02266@nifty.ne.jp>

	* configure.in: Removed. (no support the Autoconf version 2.13).

	* config.h.in: Changed meaning of the value of the `MULTIBYTE_FILENAME'.

	* src/header.c: Remove preprocess codes for kanji code decision.

	* configure.ac: When --enable-multibyte-filename[=auto] is specified,
	decide kanji code for filename automatically.
	Otherwise, euc or sjis is specified, it is EUC-JP or Shift_JIS.

2002-06-17  Koji Arai  <jca02266@nifty.ne.jp>

	* configure.in, configure.ac: updated version.

	* configure.in, configure.ac: On mingw-runtime-2.0-1, opendir()
	has moved to libmingwex.a. For now, not listed in the
	/usr/lib/gcc-lib/i686-pc-cygwin/2.95.3-5/specs file.

	* src/lharc.c (message): use variable argument list with stdarg.
	(warning): ditto.
	(error): ditto.
	(write_error): removed.
	(read_error): removed.
	(build_temporary_name): use xsnprintf().
	(open_old_archive): ditto.
	(expanded_archive_name): move in the function (open_old_archive()) as static.

	* src/crcio.c (putcode): changed for fatal_error().
	(putbits): changed for fatal_error().
	(fwrite_crc): ditto.
	(putc_euc): should return EOF when putc() cause error.
	(fwrite_txt): changed for putc_euc().

	* src/header.c (get_header): changed for fatal_error(), warning() and error().
	(init_header): use xsnprintf().
	(write_header): fixed wrong usage of fwrite().

	* src/lha.h: updated declarations.

	* src/lhadd.c (append_it): changed for error().

	* src/lhext.c (inquire_extract): ditto.

	* src/lhlist.c (cmd_list): ditto.

	* src/maketbl.c (make_table): ditto.

	* src/util.c (copyfile): changed for fatal_error().
	(xsnprintf): newly added to adopt to various snprintf().

2002-06-12  Koji Arai  <jca02266@nifty.ne.jp>

	* src/lha_macro.h (UNIX_STICKYBIT): fixed a misspelling.

	* src/lhlist.c (list_one): ditto.

2002-06-11  Koji Arai  <jca02266@nifty.ne.jp>

	* src/lharc.c: index was wrong.
	  reported on LHa BBS (see <http://www2m.biglobe.ne.jp/~dolphin/>).

2002-06-06  Koji Arai  <jca02266@nifty.ne.jp>

	* configure.ac, configure.in: changed macro name.
	not multibyte-char but multibyte-filename.
	not MULTIBYTE_CHAR but MULTIBYTE_FILENAME.

	* 00readme.autoconf: ditto.

	* config.h.in: ditto.

	* src/util.c: ditto.

	* src/lha_macro.h: ditto.

	* src/header.c: ditto.

	* config.h.in (INCLUDE_OWNER_NAME_IN_HEADER): changed macro name.

	* configure.ac: ditto.

	* src/header.c (init_header): ditto.

	* src/header.c (init_header): should clear LzHeader.

2002-06-05  Koji Arai  <jca02266@nifty.ne.jp>

	* released.

	* configure.ac (AC_INIT): changed package name and specified tar name.

	* src/lharc.c: added `--help' command line switch.

	* Makefile.am: fixed EXTRA_DIST for 00readme.autoconf renaming.

	* README.autoconf, 00readme.autoconf: renamed.

	* configure.ac, configure.in: updated version.

2002-06-04  Koji Arai  <jca02266@nifty.ne.jp>

	* README.autoconf, header.doc.euc: describe about user/group name
	header.

	* src/header.c (init_header): added a macro MAKE_USER_NAME_HEADER.

	* configure.ac, configure.in, config.h.in: added a switch
	`--enable-user-name-header' whether user/name extended header is
	made.

2002-06-01  Koji Arai  <jca02266@nifty.ne.jp>

	* README.autoconf: `-i' switch of automake is deprecated.

2002-05-29  Koji Arai  <jca02266@nifty.ne.jp>

	* configure.in, configure.ac, config.h.in: checks having uid_t/gid_t.

	* src/lha.h: define uid_t/gid_t as `int' if no have it.

	* src/lhext.c (adjust_info): mismatched braces.

	* header.doc.euc: around user/group name extention.

	* configure.in, configure.ac, config.h.in: checks having
	getpwuid/getgrgid and so on.

	* src/header.c (get_header): use the extend header, user/group name.
	(init_header): ditto.

	* src/lha.h: added <pwd.h>, <grp.h> header includings.

	* src/lhext.c (adjust_info): change owner/group according to
	user/group name when extracting.

	* src/lhlist.c (list_one): print user/group name when the header
	has them.
	(list_one): correct column position on OS68K.

	* tests/lha-test.in: added timestamp checks.

	* src/lha_macro.h: comment about OS code.

2002-05-28  Koji Arai  <jca02266@nifty.ne.jp>

	* src/lharc.c (xstrdup): no need to call fatal_error().

	* src/lhdir.h, src/lha_macro.h, src/lha.h: added modeline for vi(m).

	* configure.ac, config.h.in: use new autoconf macro, AC_CHECK_MEMBERS().

	* IFNAMES, configure.in, src/header.c, src/lharc.c: replaced with
	new macro name to adopt to the AC_CHECK_MEMBERS().

2002-05-27  Koji Arai  <jca02266@nifty.ne.jp>

	* tests/lha-test.in: use awk instead of GNU sh-utils's `seq'.

	* src/header.c (filename_conv): fix a bug, reverse condition and
	conversion for filename case.

	* README.autoconf: added description about `get_filename_from_stdin' feature.

	* tests/lha-test.in: remove test around the `get_filename_from_stdin'.

	* src/lharc.c (main): never set `get_filename_from_stdin` to true.
	`echo foo | lha x foo.lzh' does not work like original LHa for UNIX.

	* tests/lha-test.in: replace with #!/bin/bash.

	* README.autoconf: added E-Mail address.

	* configure.ac: updated version and added mail address for bug reports.

	* configure.in: updated version.

	* released.

	* README.autoconf: added `make check' on sample description.

	* configure.in, configure.ac: update version.

2002-05-26  Koji Arai  <jca02266@nifty.ne.jp>

	* tests/lha-test.in: added some tests.

	* tests/Makefile.am: refined.

	* src/lhext.c (cmd_extract): discard useless fseek() calling (for MinGW).

	* tests/lha-test.in: added some tests.

	* tests/lha-test.in: specified `q' option on print archive test.

	* src/lhadd.c (build_backup_file): On MinGW, cannot rename when
	a new file already exists.

	* src/lhext.c (extract_one): On MinGW, set binary on stdout when
	print archive (`p' switch).

	* tests/lha-test.in: added some tests.

	* src/lhadd.c (report_archive_name_if_different): warning messages
	should be printed to stderr rather than stdout.
	(cmd_delete): ditto.

	* tests/Makefile.am: fix EXTRA_DIST.

	* configure.in, configure.ac: update version.

	* tests/lha-test.in: added tests.

	* tests/Makefile.am: ditto.

	* configure.in, configure.ac, Makefile.am: ditto.

2002-05-25  Koji Arai  <jca02266@nifty.ne.jp>

	* IFNAMES: updated.

	* released.

	* README.autoconf: added description for developpers.

	* configure.in, configure.ac, config.h.in: refined.

	* src/util.c (memmove): use HAVE_MEMMOVE.
	(mkdir): use HAVE_WORKING_FORK.

	* src/huf.c: use HAVE_SYS_PARAM_H instead of sony_news.

	* IFNAMES (sony_news): updated.

	* configure.ac, configure.in (AC_INIT): added autoconfiscated date.
	see `lha --version'.

2002-05-22  Koji Arai  <jca02266@nifty.ne.jp>

	* src/append.c, src/crcio.c, src/dhuf.c, src/extract.c, src/header.c, src/huf.c, src/larc.c, src/lhadd.c, src/lharc.c, src/lhdir.c, src/lhext.c, src/lhlist.c, src/maketbl.c, src/maketree.c, src/patmatch.c, src/shuf.c, src/slide.c, src/util.c:
	added modeline for vi(m).

	* src/lharc.c: backslash was missing.

2002-05-20  Koji Arai  <jca02266@nifty.ne.jp>

	* src/lharc.c (open_old_archive):  On MinGW, set binary stdin.

	* src/lhadd.c (temporary_to_new_archive_file): On MinGW, set binary stdout.

	* src/lha_macro.h: no define TMP_FILENAME_TEMPLATE in source.

	* configure.ac, configure.in, README.autoconf: be able to specify
	--with-tmp-file=no which meaning TMP_FILENAME_TEMPLATE is undefined.

	* src/lha.h: correct usage of mkstemp().
	On MinGW, opening file cannot be removed.

	* src/lhadd.c (build_temporary_file): ditto.

	* src/lharc.c (fatal_error): ditto.

2002-05-19  Koji Arai  <jca02266@nifty.ne.jp>

	* configure.in, configure.ac: added AM_C_PROTOTYPES, AC_C_CONST.
	no use AM_C_PROTOTYPES for the present.

	* config.h.in: ditto.

	* src/lharc.c (print_tiny_usage_and_exit): change credit.

	* src/lha_macro.h: put PLATFORM in a macro LHA_VERSION.

	* src/lharc.c (print_version): ditto.

	* configure.ac: use AC_CANONICAL_TARGET instead of AC_CANONICAL_HOST.

2002-05-19  Koji Arai  <jca02266@nifty.ne.jp>

	* released.

	* src/lharc.c (print_tiny_usage_and_exit): added credit.
	(print_version): print PLATFORM.

	* configure.ac, configure.in, config.h.in: define PLATFORM.

	* src/lharc.c (xstrdup): fix typo.

	* configure.ac: added for autoconf-2.53.

	* config.h.in: regenerate by autoconf-2.53.

	* src/lharc.c (find_files): MinGW has st_ino but always 0.

	* src/lharc.c (main): provisionally fix. set
	`get_filename_from_stdin' to false.

	* src/util.c (rename): use builtin rename(2) on mingw32 (since have
	no link(2)).

	* src/lharc.c (main): use xrealloc().

	* src/lha_macro.h: specify "b" modifier always (for mingw32).

	* src/lharc.c: use xstrdup() instead of strdup().

	* src/lha_macro.h: ditto.

	* src/lha_macro.h: getuid(), chown(), kill() are provisionally
	defined as 0.

	* src/header.c: set `default_system_kanji_code' to Shift_JIS on mingw32.

	* src/lhadd.c (build_temporary_file): no use SIGHUP for mingw32.
	(build_backup_file): ditto.

	* src/lharc.c (interrupt): ditto.

	* src/lhext.c (extract_one): ditto.

	* src/lhext.c (make_parent_path): mkdir() has no 2nd argument on
	mingw32.

2002-05-18  Koji Arai  <jca02266@nifty.ne.jp>

	* lha_macro.h: define bcmp(), bzero(), bcopy() even if
	STDC_HEADERS is defined.

	* huf.c (alloc_buf): call fatal_error() when memory allocation failed
	instead of returning NULL.

	* lharc.c (main): use xmalloc().

	* util.c (copyfile): use xmalloc().

	* slide.c (encode_alloc): use xmalloc().

	* header.c (default_system_kanji_code): On HP-UX, use Shift_JIS as
	default kanji code.

2001-02-03  Koji Arai  <jca02266@nifty.ne.jp>

	* README.autoconf, src/header.c: treat archive and system kanji
	code, correctly.

2001-01-31  Koji Arai  <jca02266@nifty.ne.jp>

	* configure.in: mistakes for default archive method.

	* src/header.c: directory separator 0xff must be transpose slash
	at first.

2001-01-29  Koji Arai  <jca02266@nifty.ne.jp>

	* src/lharc.c: replace MKSTEMP with HAVE_MKSTEMP.
	substitute DEFAULT_LZHUFF_METHOD for the `compress_method' variable (it's default value).

	* src/lha_macro.h: use the VERSION macro (defined by configure) for
	the LHA_VERSION definition.

	* src/header.c: added condition whether the macro MULTIBYTE_CHAR
	is defined or not.

	* src/Makefile.am: added $(SUPPORT_LZHUFF_METHOD) in AM_CPPFLAGS.

	* configure.in: change version number from 1.14f to 1.14i.
	check function mkstemp().
	replace --enable-lh6 option to --with-default-method=[567].

	* config.h.in: added definitions of HAVE_MKSTEMP and
	DEFAULT_LZHUFF_METHOD.

	* IFNAMES: added a description about MKSTEMP.

	* Makefile.am: added extra files.

	* change-114f.txt, src/extract.c, src/header.c, src/huf.c, src/lha.h, src/lha_macro.h, src/lhadd.c, src/lharc.c, src/lhext.c, src/lhlist.c, src/maketbl.c, src/maketree.c, src/shuf.c, src/slide.c, src/util.c, src/dhuf.c, src/crcio.c:
	merged changing from lha-1.14f to lha-1.14i.

	* change-114i.txt, src/header.c, src/huf.c, src/lha.h, src/lharc.c:
	import lha-114i

	* src/huf.c, src/lharc.c, src/shuf.c, src/slide.c: import lha-114h

	* Makefile, README.euc, change-114g.txt, change-114h.txt:
	import lha-114h

	* src/crcio.c, src/dhuf.c, src/extract.c, src/header.c, src/huf.c, src/lha.h, src/lha_macro.h, src/lhadd.c, src/lharc.c, src/lhext.c, src/util.c:
	import lha-114g

	* MACHINES2.euc, Makefile, README.euc, change-114g.txt, config.eng, config.jpn.euc, header.doc.euc, src/lhlist.c, src/maketbl.c, src/maketree.c, src/makezero.c, src/shuf.c, src/slide.c:
	import lha-114g

	* src/header.c, src/lha_macro.h: implemented kanji code conversion
	on filename.

	* src/header.c: fix bug in euc2sjis().

1999-10-05  Koji Arai  <jca02266@nifty.ne.jp>

	* src/header.c: rename the macro HANKAKU_KATAKANA_P to the X0201_KANA_P

1999-09-30  Koji Arai  <jca02266@nifty.ne.jp>

	* IFNAMES, configure.in, Makefile.in.org, README.autoconf, config.h.in, man/Makefile.am, src/Makefile.am, src/Makefile.in.org, Makefile.am, src/header.c, src/huf.c, src/larc.c, src/lha.h, src/lha_macro.h, src/lhadd.c, src/lharc.c, src/lhdir.c, src/lhdir.h, src/lhext.c, src/lhlist.c, src/makefile.dj, src/maketbl.c, src/maketree.c, src/patmatch.c, src/shuf.c, src/slide.c, src/util.c, Makefile, man/Makefile, src/Makefile, src/append.c, src/crcio.c, src/dhuf.c, src/extract.c:
	use the autoconf/automake

1999-08-28  Koji Arai  <jca02266@nifty.ne.jp>

	* Makefile: import the lha-114f

	* change-114f.txt, config.jpn.euc, header.doc.euc: import the lha-114f

	* CHANGES.euc, MACHINES.euc, PROBLEMS.euc, README.euc, change-114e.txt, config.eng:
	import the lha-114f

	* MACHINES2.euc, man/Makefile, man/lha.man, man/lha.n:
	import the lha-114f

	* src/append.c, src/crcio.c: import the lha-114f

	* src/Makefile, src/lha.h, src/lha_macro.h, src/lharc.c, src/lhdir.c, src/lhdir.h, src/lhext.c, src/lhlist.c, src/makefile.dj, src/maketbl.c, src/maketree.c, src/patmatch.c, src/shuf.c, src/slide.c, src/util.c:
	import the lha-114f

	* src/dhuf.c, src/extract.c, src/header.c, src/huf.c, src/larc.c, src/lhadd.c:
	import the lha-114f
